/*
 * Copyright (C) 2014 University of Stuttgart, IKR
 *
 * This file is part of IKR tcp-mux-client as available from
 * http://www.ikr.uni-stuttgart.de/IKRSimLib.
 *
 * This file is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License (GPL)
 * as published by the Free Software Foundation, in version 2 as it
 * comes in the file "COPYING" in directory doc of IKR tcp-mux-client.
 *
 * IKR tcp-mux-client is distributed in the hope that it will be useful, but
 * without any warranty of any kind. Please contact the IKR if you
 * need additional information (http://www.ikr.uni-stuttgart.de).
 *
 * Alternatively you may license IKR tcp-mux-client under a different
 * (non-free) license. Please contact the IKR for further details.
 *
 */

#ifndef TCP_MUX_CLIENT_H
#define TCP_MUX_CLIENT_H

#define MUX_MSG_START 0

#define MUX_MSG_GETSOCKOPT 20
#define MUX_MSG_SETSOCKOPT 21
#define MUX_MSG_GETSOCKNAME 22
#define MUX_MSG_GETPEERNAME 23

#define MUX_MSG_SOCKET_CONNECT    100
#define MUX_MSG_CLOSE   101
#define MUX_MSG_WRITE   102
#define MUX_MSG_READ    103
#define MUX_MSG_SOCKET_BIND_LISTEN  104
#define MUX_MSG_ACCEPT  105
#define MUX_MSG_WRITE_RET 106
#define MUX_MSG_WRITABLE 107
#define MUX_MSG_BIND_RET 108

#define MUX_MSG_CONNECT 200

#define MUX_MSG_DATA_AVAILABLE 303
#define MUX_MSG_CLIENT_AVAILABLE 305

#define MUX_MSG_UTP_SOCKET_CONNECT 400
#define MUX_MSG_UTP_SOCKET_BIND_LISTEN  401

#define MUX_MSG_CREATED_SOCK 600
#define MUX_MSG_READ_FILE 601
#define MUX_MSG_WRITE_FILE 602
#define MUX_MSG_RESET_RNG 603

#define TRIGGER_MSG_SIZE 12
#define FD_SIZE (sizeof(uint32_t))

// padding bytes are required for the legacy serial interface. all messages are padded to a multiple of this value
#define PADDING_BYTES 8

#endif
